if(jQuery) (function($){
	
	$.extend($.fn, {
		violetTree: function(o) {
			if( !o ) var o = {};
			if( o.user == undefined ) o.user = null;
			if( o.homeDirNameDisplay == undefined ) o.homeDirNameDisplay = 'Home';
			if( o.script == undefined ) o.script = null;
			if( o.dataSource == undefined ) o.dataSource = 'AJAX'; //'LOADED' 
			if( o.data == undefined ) o.data = null;
			if( o.container == undefined ) o.container = $(this);
			if( o.dirIDprefix == undefined ) o.dirIDprefix = 'vsdir_';

			if( o.expandSpeed == undefined ) o.expandSpeed= 500;
			if( o.collapseSpeed == undefined ) o.collapseSpeed= 500;
			if( o.expandEasing == undefined ) o.expandEasing = null;
			if( o.collapseEasing == undefined ) o.collapseEasing = null;

			// PRIVATE methods
			var loadTree = function () {
				if (o.dataSource == 'AJAX') {
					$.post(o.script, 
						function(data){
							if (!data) return;
							var parsedData = $.parseJSON(data);
							o.data = parsedData;
							renderTree ();
						}
					).done(function() {}).fail(function() {}).always(function() {});
				}				
			};

			var renderTree = function  () {
				var homeNode = createNode({
					id:0,
					name:o.homeDirNameDisplay,
				});

				selectDir($(homeNode).find('> A'));

				if (o.data != null) {
					for (var i = 0; i < o.data.length ; i++) {
						var node = createNode ({
							id: o.data[i].id,
							name: o.data[i].name,
							curentNode: $('#' + o.dirIDprefix + o.data[i].parentID).find('> A'),
							hidden: (o.data[i].parentID > 0) ? true : false
						})
					};
				}
			};

			//Create a node of Tree
			var createNode = function (d) {
				if( !d ) var d = {};
				if( d.id == undefined ) d.id = null;
				if( d.name == undefined ) d.name = null;
				if( d.curentNode == undefined ) d.curentNode = null;
				if( d.hidden == undefined ) d.hidden = true;
				if( d.clickEvent == undefined ) d.clickEvent = openDir;
				if( d.customEvent == undefined ) d.customEvent = null; //customEvent.eventName, customEvent.eventTrigger
				
				if (d.curentNode != null) {
					var strHTML = '<ul class="jqueryFileTree"><li id="' + o.dirIDprefix + d.id + '" class="directory collapsed"><a href="#" rel="' + d.name + '">' + d.name + '</a></li></ul>';

					$(d.curentNode).parent().append(strHTML);
					if (d.hidden == true) 
						$('#' + o.dirIDprefix + d.id).parent().css('display','none');
					
				}else if (d.id == 0){
					var strHTML = '<ul class="jqueryFileTree"><li id="' + o.dirIDprefix + d.id + '" class="home"><a href="#" rel="' + d.name + '">' + d.name + '</a></li></ul>';
					$(o.container).append(strHTML);
				}

				//bind event on new node
				$('#' + o.dirIDprefix + d.id).find('a').bind("click", function(e){d.clickEvent(this)});
				$('#' + o.dirIDprefix + d.id).find('a').bind("contextmenu",function(e){
			        e.preventDefault();
			        showContextMenu (this);
				});

				if (d.customEvent != null) 
					$('#' + o.dirIDprefix + d.id).find('a').bind(d.customEvent.eventName, function(e){d.customEvent.eventTrigger(this)});

				return $('#' + o.dirIDprefix + d.id);
			}
			//END - Create a node of Tree

			var deleteNode = function (n) {
				if (!$(n).parent().hasClass('home'))
					$(n).remove();
			}

			var isHome = function (n) {
				return $(n).parent().hasClass('home');
			}

			var countNodeChild = function (n) {
				var parent = $(n).parent();
				return $(parent).find('UL').size();
			}

			var openDir = function (o) {
				if( $(o).parent().hasClass('collapsed') ) {
					$(o).parent().find('> UL:hidden').slideDown({ duration: o.expandSpeed, easing: o.expandEasing });
					$(o).parent().removeClass('collapsed').addClass('expanded');
				}
				else if( $(o).parent().hasClass('expanded') ) {
					$(o).parent().find('> UL').slideUp({ duration: o.collapseSpeed, easing: o.collapseEasing });
					$(o).parent().removeClass('expanded').addClass('collapsed');
				}
				selectDir(o);
			}

			var selectDir = function (c) {
				$('.currentDir').removeClass('currentDir');
				$(c).addClass('currentDir');
			}

			var showContextMenu = function  (n) {
				alert ('showContextMenu on ' + $(n).text());
			};

			loadTree();
			// END - PRIVATE methods


			this.expandAll = function() {
				$(o.container).find('UL:hidden').slideDown({ duration: o.expandSpeed, easing: o.expandEasing });
			};

			this.getCurrentDirName = function() {
				return $(o.container).find('.currentDir').attr('rel');
			};

			this.getCurrentDir = function() {
				return $(o.container).find('.currentDir');
			};

			this.createDir = function(c) {

				var cid = $(c).parent().attr('id');
				var pid = cid.substring(o.dirIDprefix.length, cid.length);

				var dirName = prompt("Please enter new directory name", "");

				$.post(o.script,{action:"create_dir",parentID:pid,name:dirName}, function (data) {
					if (!data) return;
					var parsedData = $.parseJSON(data);

					createNode({
						id: parsedData.id,
						name: parsedData.name,
						curentNode: c,
						hidden: false,
						//customEvent: {eventName: "click", eventTrigger: function(o){alert('This click!')}}
					});
				});
			}

			this.deleteDir = function (c) {
				var childExisted = (countNodeChild(c) > 0) ? true:false;
				var confirmDel = false;
				var confirmChild = true;

				if (isHome(c)) return;

				confirmDel = confirm('Are you sure you want to delete this Directory?');

				if (childExisted > 0 && confirmDel)
					confirmChild = confirm('This node has childs, you still want to delete it?');

				if (confirmDel && confirmChild)	deleteNode(c);

			}

			this.initialize = function() {
        		return this;
    		};

			return this.initialize();
		},
	});

})(jQuery);